﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.UI;
using FilteredPageReference;

namespace CustomizablePageReference
{
    /// <summary>
    /// Property customizable page reference control.
    /// </summary>
    public class PropertyCustomizablePageReferenceControl : PropertyFilteredPageReferenceControl
    {
        /// <summary>
        /// Gets or sets the settings.
        /// </summary>
        /// <value>
        /// The settings.
        /// </value>
        public PropertyFilteredPageReferenceSettings Settings { get; set; }

        /// <summary>
        /// Initializes a new instance of the
        /// <see cref="PropertyCustomizablePageReferenceControl"/> class.
        /// </summary>
        /// <param name="settings">The settings.</param>
        public PropertyCustomizablePageReferenceControl(
            PropertyFilteredPageReferenceSettings settings)
        {
            Settings = settings;
        }

        /// <summary>
        /// Initializes settings for property.
        /// </summary>
        protected virtual void InitializeSettings()
        {
            SettingsUtility.UpdateSettings(PropertyData, Settings);
        }

        /// <summary>
        /// Renders the control to the specified HTML writer.
        /// </summary>
        /// <param name="writer">The <see cref="T:System.Web.UI.HtmlTextWriter"/>
        /// object that receives the control content.</param>
        protected override void Render(HtmlTextWriter writer)
        {
            InitializeSettings();

            base.Render(writer);
        }
    }
}
